package com.mortals.xhx.test0002;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author liaoxin
 * @Date: 2021-08-2021/8/6-14:10
 * @Description:
 */
public class teeee {
    public static void main(String[] args) {
        String areaCode ="";
        String url = "http://www.sczwfw.gov.cn/jiq/interface/jitem/find-by-code?code="+areaCode+"&deptType=1&jsonpCallback=jsonpcallback&_=1610010351147";
        HttpResponse execute = HttpRequest.get(url).execute();
        String body = execute.body();
        StringBuffer stringBuffer = new StringBuffer(body);
        String substring1 = stringBuffer
                .deleteCharAt(stringBuffer.lastIndexOf("("))
                .deleteCharAt(stringBuffer.lastIndexOf(")"))
                .substring(getFromIndex("k", "jsonpcallback"));
        JSONObject jsonObject = JSONObject.parseObject(substring1);
        List<testModel> testModels = jsonObject
                .getJSONObject("data")
                .getJSONObject("group")
                .getJSONArray("sonAreas")
                .toJavaList(testModel.class);
        Map<String, Object> regionString = getRegionString(jsonObject);
        System.out.println(JSONArray.toJSONString(regionString));

    }

    public static Map<String,Object> getRegionString(JSONObject jsonObject) {
        Map<String, Object> stringObjectHashMap = new HashMap<>();
        Map<String, String> stringStringHashMap = new HashMap<>();
        List<Object> objects = new ArrayList<>();
        JSONObject jsonObject1 = jsonObject
                .getJSONObject("data")
                .getJSONObject("group");
        stringStringHashMap.put("areaName",jsonObject1.getString("name"));
        stringStringHashMap.put("areaCode",jsonObject1.getString("areaCode"));
        objects.add(stringStringHashMap);
        stringObjectHashMap.put("省",objects);
//        stringObjectHashMap.put("市","");
//        stringObjectHashMap.put("区/县","");
        if (!"3".equals(jsonObject1.getString("areaLevel")) ){
//            return getRegionString();
        }

        return stringObjectHashMap;
    }

    //获取k在jsonpcallback第一次出现的下标
    private static int getFromIndex(String str, String str1) {
        //子字符串modelStr在字符串str中第count次出现时的下标
        //对子字符串进行匹配
        Matcher matcher = Pattern.compile(str).matcher(str1);
        int index = 0;
        //matcher.find();尝试查找与该模式匹配的输入序列的下一个子序列
        while (matcher.find()) {
            index++;
            //当modelStr字符第count次出现的位置
            if (index == 1) {
                break;
            }
        }
        return matcher.start()+1;
    }

}